"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const run_1 = __importDefault(require("./run"));
const cli = __importStar(require("@bearer/cli/lib/index"));
// @ts-ignore
cli.run = jest.fn(() => Promise.resolve());
describe('run', () => {
    describe('when -t options is passed', () => {
        beforeEach(() => {
            // @ts-ignore
            cli.run.mockReset();
        });
        describe('when empty', () => {
            it('fallbacks on bearer template url', () => __awaiter(this, void 0, void 0, function* () {
                yield run_1.default('aName', '-t', '--authType', 'ok');
                expect(cli.run).toHaveBeenCalledWith([
                    'new',
                    'aName',
                    '-t',
                    'https://github.com/Bearer/templates',
                    '--authType',
                    'ok'
                ]);
            }));
        });
        describe('when empty and latest', () => {
            it('fallbacks on bearer template url', () => __awaiter(this, void 0, void 0, function* () {
                yield run_1.default('aName', '-t');
                expect(cli.run).toHaveBeenCalledWith(['new', 'aName', '-t', 'https://github.com/Bearer/templates']);
            }));
        });
        describe('when present', () => {
            it('does not change', () => __awaiter(this, void 0, void 0, function* () {
                yield run_1.default('aName', '-t', 'anotherUrl', '--authType', 'ok');
                expect(cli.run).toHaveBeenCalledWith(['new', 'aName', '-t', 'anotherUrl', '--authType', 'ok']);
            }));
        });
    });
});
